## Commander-Genius-v3.5.1.tar.bz2

=== CMakeLists.txt ===
# CMake file for development of Commander Genius (taken from OLX)
# This CMake file is used under Linux normally.

cmake_minimum_required(VERSION 3.7)

Project(CommanderGenius)

IF(WIN32)
SET(DATADIR CGenius)
SET(APPDIR CGenius)
SET(GAMES_SHAREDIR "${APPDIR}" CACHE PATH "Game data root dir")
SET(DOCDIR ${DATADIR} CACHE PATH "Docs destination")
ELSE(WIN32)
SET(SHAREDIR "/usr/share" CACHE PATH "System share dir location")
SET(GAMES_SHAREDIR "${SHAREDIR}/games/" CACHE PATH "Game data root dir")
SET(DATADIR "${GAMES_SHAREDIR}/commandergenius")
SET(APPDIR games CACHE PATH "Binary destination")
SET(DOCDIR ${DATADIR} CACHE PATH "Docs destination")
SET(ICONDIR "${SHAREDIR}/icons/hicolor" CACHE PATH "Standard icon installation dir")
SET(DESKTOPFILESDIR "${SHAREDIR}/applications" CACHE PATH "Application installation dir")
ENDIF(WIN32)

if (OSXCROSS)
message(STATUS "OSXCross is enabled")
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
include(${CMAKE_TOOLCHAIN_FILE})
endif()


option(USE_VIRTUALPAD "Enable Onscreen Virtual Gamepad support " ON)

option(EMBEDDED "Set this to yes, if you want a build for embedded systems" OFF)

if(ALTERNATE_HOME)
    ADD_DEFINITIONS(-DALTERNATE_HOME="${ALTERNATE_HOME}")
    MESSAGE(STATUS "ALTERNATE_HOME=${ALTERNATE_HOME}")
endif(ALTERNATE_HOME)

if(EMBEDDED)
    ADD_DEFINITIONS(-DEMBEDDED)
endif(EMBEDDED)

if(USE_VIRTUALPAD)
    ADD_DEFINITIONS(-DUSE_VIRTUALPAD)
endif(USE_VIRTUALPAD)

# In case you want a switch build
OPTION(NINTENDO_SWITCH "Build for Nintendo Switch" No)

if(NINTENDO_SWITCH)
    ADD_DEFINITIONS(-D__SWITCH__)
endif(NINTENDO_SWITCH)


# GP2X builds
OPTION(GP2X "Build for GP2X" No)

if(GP2X)
    ADD_DEFINITIONS(-D__GP2X__)
endif()


OPTION(DUMP_MTCS "Show Mouse Touch Cursor Position" No)

IF (DUMP_MTCS)
    ADD_DEFINITIONS(-DDUMP_MTCS)
endif(DUMP_MTCS)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache) # Less useful to do it for linking, see edit2
    message(STATUS "Using ccache for faster builds")
endif(CCACHE_FOUND)

# Will pass the SHA and branch strings to the executable
find_program(GIT_FOUND git)
if(GIT_FOUND)
    message(STATUS "Found Git (${GIT_FOUND}), executable will get SHA and branch used")
    execute_process(COMMAND ${GIT_FOUND} -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
                    OUTPUT_VARIABLE GIT_SHA
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_FOUND} -C ${CMAKE_SOURCE_DIR} rev-parse --abbrev-ref HEAD
                    OUTPUT_VARIABLE GIT_BRANCH
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    ADD_DEFINITIONS(-DGIT_SHA=${GIT_SHA})
    ADD_DEFINITIONS(-DGIT_BRANCH=${GIT_BRANCH})
    message(STATUS "GIT_SHA = ${GIT_SHA}")
    message(STATUS "GIT_BRANCH = ${GIT_BRANCH}")
else(GIT_FOUND)
    ADD_DEFINITIONS(-DGIT_SHA=none)
    ADD_DEFINITIONS(-DGIT_BRANCH=none)
endif(GIT_FOUND)

# Pass correct definition for SYSTEM_DATA_DIR so packager or distributors can decide where the app should land in
if(UNIX)
        if(NOT IS_ABSOLUTE ${GAMES_SHAREDIR})
                set(FULL_GAMES_SHAREDIR "${CMAKE_INSTALL_PREFIX}/${GAMES_SHAREDIR}" CACHE PATH "Full where the games will be stored")
        else()
                set(FULL_GAMES_SHAREDIR ${GAMES_SHAREDIR} CACHE PATH "Full where the games will be stored")
        endif()
endif(UNIX)

set(SYSTEM_DATA_DIR "${FULL_GAMES_SHAREDIR}" CACHE PATH "System data where CG will access to" )
MESSAGE(STATUS "Setting SYSTEM_DATA_DIR to ${SYSTEM_DATA_DIR}" )
add_definitions(-DSYSTEM_DATA_DIR="${SYSTEM_DATA_DIR}")


# Add GsKit
add_subdirectory("GsKit")

option(DISABLE_HOVER "Disables the hover over effect in the menus, useful for touch based devices" OFF)

if(DISABLE_HOVER)
    ADD_DEFINITIONS(-DDISABLE_HOVER)
endif()

# Modules path located at GsKit/CMake
#set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/GsKit/CMake")

if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
    elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
    endif()
endif()

#------------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
else()
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
endif()

# Since shell script get_version is not processed properly on windows, we have to define manually here.
# TODO: Better system for defining the version
set(CG_VERSION "3.5.1")

MESSAGE(STATUS "Preparing the Build-System for Commander Genius" )
execute_process(COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/get_version.sh OUTPUT_VARIABLE CG_VERSION)
string(REGEX REPLACE "[\r\n]" "" CG_VERSION "${CG_VERSION}")

# Generate the README file with the correct version string
configure_file(README.md ${CMAKE_BINARY_DIR}/README.md COPYONLY)
configure_file(README.md ${CMAKE_CURRENT_SOURCE_DIR}/README.md COPYONLY)
configure_file(README.md ${CMAKE_CURRENT_SOURCE_DIR}/debian/README.md COPYONLY)
configure_file(GsKit/LICENSE ${CMAKE_BINARY_DIR}/LICENSE COPYONLY)

if(APPLE)
    file(COPY cglogo.icns DESTINATION ${CMAKE_BINARY_DIR}/src)
    file(COPY Info.plist DESTINATION ${CMAKE_BINARY_DIR}/src)
    file(COPY launchCGonMacOs.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY buildMacOsBundle.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY makebundleable.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY get_version.sh DESTINATION ${CMAKE_BINARY_DIR})
    file(COPY version.h DESTINATION ${CMAKE_BINARY_DIR})
    SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -headerpad_max_install_names")
endif(APPLE)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")


# Check that GsKit also has been loaded
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/GsKit/CMakeLists.txt")
    MESSAGE(FATAL_ERROR "You need to have the sources of GsKit in order to build Commander Genius. ")
endif()

# And build Commander Genius on top of that!
add_subdirectory("src")

add_custom_target(${PROJECT_NAME} SOURCES changelog.txt README.md)

MESSAGE(STATUS "CG_VERSION = ${CG_VERSION}" )

INCLUDE(package.cmake)

MESSAGE( STATUS "Build system is prepared. To Build the project just type \"make\"" )
MESSAGE( STATUS "If you want to create the installation package just type \"make package\" after you build the project" )

=== GsKit/CMakeLists.txt ===
# CMake file for development of Commander Genius (taken from OLX)
# This CMake file is used under Linux normally.

cmake_minimum_required(VERSION 3.7)

Project(GsKit)

OPTION(USE_BOOST "Use Boost for XML" No)

option(DISABLE_HOVER "Disables the hover over effect in the menus, useful for touch based devices" OFF)

if(DISABLE_HOVER)
    ADD_DEFINITIONS(-DDISABLE_HOVER)
endif()

option(USE_CRASHHANDLER "Enables the Crash Handler" ON)
if(USE_CRASHHANDLER)
    ADD_DEFINITIONS(-DUSE_CRASHHANDLER)
endif()

OPTION(USE_OPENGL "OpenGL support" No)


if(USE_BOOST)
    set(Boost_USE_STATIC_LIBS OFF)
    set(Boost_USE_MULTITHREAD ON)
    set(Boost_USE_STATIC OFF)

    FIND_PACKAGE(Boost)
    IF (Boost_FOUND)
            INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
            ADD_DEFINITIONS( "-DBOOST_ENABLED" )
    ELSE(Boost_FOUND)
            MESSAGE(FATAL_ERROR "Could not find the Boost libraries")
    ENDIF(Boost_FOUND)
endif(USE_BOOST)


INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})


if(CMAKE_SYSTEM_NAME MATCHES "Emscripten")

  set(CMAKE_CXX_FLAGS_INIT "-s WASM=1 -s USE_SDL=2 -s USE_SDL_IMAGE=2 -s SDL2_IMAGE_FORMATS='[\"png\"]'")
  set(CMAKE_EXE_LINKER_FLAGS_INIT "-s WASM=1 -s USE_SDL=2 -s USE_SDL_IMAGE=2 -s SDL2_IMAGE_FORMATS='[\"png\"]'")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_INIT}")
  set(CMAKE_EXE_LINKER "${CMAKE_EXE_LINKER_FLAGS_INIT} -s EXTRA_EXPORTED_RUNTIME_METHODS='[\"ccall\", \"cwrap\"]'")

  # TODO: Needs rework
  add_library(GsKit STATIC ${ALL_SRCS_GSKIT_BASE})

else()

    # Hack which on some systems helps linking this lib correctly
    # (required for mac builds)
    file(WRITE null.cpp "")
    add_library(${PROJECT_NAME} LICENSE null.cpp LICENSE)


    if(SDL2)
        OPTION(USE_OPENGL "OpenGL support" No)
    else()
        OPTION(USE_OPENGL "OpenGL support" Yes)
    endif()

    option(USE_VIRTUALPAD "Enable Onscreen Virtual Gamepad support " ON)

    if(USE_VIRTUALPAD)
        ADD_DEFINITIONS(-DVIRTUALPAD)
    endif(USE_VIRTUALPAD)

    set (CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/CMake")

    if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
        set(CMAKE_CXX_STANDARD 17)
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
    else()
        if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
          set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
          set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
        elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
          set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
          set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
        endif()
    endif()

    IF(WIN32)
        ADD_DEFINITIONS(-DWIN32)
    ENDIF(WIN32)

    IF (USE_OPENGL)
            ADD_DEFINITIONS(-DGL)
            ADD_DEFINITIONS(-DUSE_OPENGL)
    ENDIF (USE_OPENGL)


    # If we want to debug set the proper flags or have release etc.
    IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
            ADD_DEFINITIONS(-DDEBUG)
            ADD_DEFINITIONS(-g)
            ADD_DEFINITIONS(-O0)
            ADD_DEFINITIONS(-Wall)
    ELSEIF(CMAKE_BUILD_TYPE STREQUAL "Release")
            ADD_DEFINITIONS(-DRELEASE)
            ADD_DEFINITIONS(-O2)
    ENDIF(CMAKE_BUILD_TYPE STREQUAL "Debug")

    IF(USE_OPENGL)
        # OpenGL Parsing
        set(OpenGL_GL_PREFERENCE GLVND)
        find_package(OpenGL REQUIRED)

        ADD_DEFINITIONS(-DGL)
        ADD_DEFINITIONS(-DUSE_OPENGL)
    ENDIF (USE_OPENGL)

    add_subdirectory(fileio)
    add_subdirectory(graphics)
    add_subdirectory(widgets)

    add_subdirectory(base)

    Target_link_libraries(${PROJECT_NAME} GsKit_base)
    Target_link_libraries(${PROJECT_NAME} GsKit_fileio)
    Target_link_libraries(${PROJECT_NAME} GsKit_widgets)
    Target_link_libraries(${PROJECT_NAME} GsKit_graphics)

IF(USE_OPENGL)
    # OpenGL stuff to link
    target_link_libraries(${PROJECT_NAME} ${OPENGL_LIBRARIES})
ENDIF(USE_OPENGL)


endif()

=== src/CMakeLists.txt ===
# Platform specific things can be put here
# Compilers and other specific variables can be found here:
# http://www.cmake.org/Wiki/CMake_Useful_Variables

OPTION(DOWNLOADER "Internal Downloader" Yes)


IF(WIN32)
        SET(BUILD_TARGET WIN32)
        ADD_DEFINITIONS(-DWIN32)
        ADD_DEFINITIONS(-DTARGET_WIN32)
ELSEIF(UNIX)
        SET(BUILD_TARGET LINUX)
ENDIF()

IF(APPLE)
    SET(BUILD_TARGET APPLE)
endif()

IF(NOT DEFINED BUILD_TARGET)
    MESSAGE( STATUS "WARNING: You did not specify the build type with the -DBUILD_TARGET= Parameter. ${BUILD_TARGET} has been choosen" )
    MESSAGE( STATUS "Available builds are: WIN32, LINUX GP2X. WIZ, CAANOO, DINGOO, NANONOTE" )
ENDIF(NOT DEFINED BUILD_TARGET)


SET(USRDIR /usr)

include(oldArch.cmake)

if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
    elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
    endif()
endif()


#Alignment error report is important for android builds
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=cast-align")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=cast-align")

# Main includes
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/GsKit)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMake)

# If we want to debug set the proper flags or have release etc.
IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
        ADD_DEFINITIONS(-DDEBUG)
        ADD_DEFINITIONS(-g)
        ADD_DEFINITIONS(-O0)
        ADD_DEFINITIONS(-Wall)
ELSEIF(CMAKE_BUILD_TYPE STREQUAL "Release")
        ADD_DEFINITIONS(-DRELEASE)
        ADD_DEFINITIONS(-O2)
ENDIF()


# Make sure the linker can find the GsKit library once it is built.
link_directories (${CMAKE_BINARY_DIR}/GsKit)

#find_package(SDL2 REQUIRED)
#find_package(SDL2_image REQUIRED)
#find_package(SDL2_ttf REQUIRED)

#if(SDL2_FOUND)
#    message(STATUS "Using shared SDL Version 2 for Commander Genius")
#    include_directories(${SDL2_INCLUDE_DIR})
#    include_directories(${SDL2_IMAGE_INCLUDE_DIR})
#endif(SDL2_FOUND)

#find_package(SDL2_mixer REQUIRED)

#if(SDL2_MIXER_FOUND)
#   INCLUDE_DIRECTORIES(${SDL2_MIXER_INCLUDE_DIRS})
#endif()

MESSAGE( STATUS "Internal Downloader: ${DOWNLOADER}" )

add_subdirectory(engine)

if(GP2X)
    add_subdirectory(sys)
endif(GP2X)

add_subdirectory(fileio)
add_subdirectory(dialog)

# Get all the o-files from the different targets and link'em
get_property(cg_obj_libs GLOBAL PROPERTY CG_OBJ_LIBS)

if(OPT_PATH)
    MESSAGE(STATUS "OPT_PATH = ${OPT_PATH}")
    link_directories(${OPT_PATH}/local/lib)
endif(OPT_PATH)


#message(STATUS "SDL2_LIBRARY = ${SDL2_LIBRARY}")
#message(STATUS "SDL2IMAGE_LIBRARY = ${SDL2IMAGE_LIBRARY}")
#message(STATUS SDL2_LINK_DIR = ${SDL2_LINK_DIR})

set(CGENIUS_SRC CGenius.cpp
    misc.cpp
    ${cg_obj_libs})

if(NINTENDO_SWITCH)
    set(CGENIUS_SRC ${CGENIUS_SRC} switch.c)
endif(NINTENDO_SWITCH)

if(${CMAKE_VERSION} VERSION_LESS "3.11.0")
    if(ANDROID)
        message(STATUS "Android build enabled. Building CG as Shared Lib")
        add_library(CGeniusExe SHARED ${CGENIUS_SRC})
    else(ANDROID)
        # Add executable Commander Genius
        add_executable (CGeniusExe ${CGENIUS_SRC})
    endif(ANDROID)
else()
    if(ANDROID)
        message(STATUS "Android build enabled. Building CG as Shared Lib")
        add_library(CGeniusExe SHARED)
    else(ANDROID)
        # Add executable Commander Genius
        add_executable (CGeniusExe)
    endif(ANDROID)

    target_sources(CGeniusExe PRIVATE ${CGENIUS_SRC})
endif()

# Since some RefKeen is used, we also need C99 Standard
set_property(TARGET CGeniusExe PROPERTY C_STANDARD 99)

# Link CG Engines
target_link_libraries (CGeniusExe engine)

# Link GsKit
target_link_libraries (CGeniusExe GsKit)


# The Windows Version has an icon in the executable
IF(WIN32)
        SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES OUTPUT_NAME "CGenius")
        find_program(WINDRES_FOUND ${CMAKE_RC_COMPILER})
        if(WINDRES_FOUND)
            ADD_CUSTOM_COMMAND(TARGET CGeniusExe PRE_LINK COMMAND ${WINDRES_FOUND} ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.rc ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.o)
            SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES LINK_FLAGS "-mwindows ${CMAKE_CURRENT_SOURCE_DIR}/CGLogo.o")
            MESSAGE(STATUS "Will build with the CG icon for Windows." )
        else()
            SET_TARGET_PROPERTIES(CGeniusExe PROPERTIES LINK_FLAGS "-mwindows")
        endif(WINDRES_FOUND)
ENDIF(WIN32)



# Only for SDL2 and Win32 since it is updated for that platform.
if(WIN32)
        target_link_libraries(CGeniusExe mingw32)
        target_link_libraries(CGeniusExe user32)
        target_link_libraries(CGeniusExe gdi32)
        target_link_libraries(CGeniusExe winmm)
        target_link_libraries(CGeniusExe imm32)
        target_link_libraries(CGeniusExe version)
endif(WIN32)

# Stuff definitions in case we want to install it
INCLUDE(install.cmake)

=== GsKit/base/CMakeLists.txt ===
# CMake file for development of Commander Genius (taken from OLX)
# This CMake file is used under Linux normally.

cmake_minimum_required(VERSION 3.7)

Project(GsKit_base)


if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
else()
    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++17")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++17")
    elseif (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.1)
      set(CMAKE_CXX17_STANDARD_COMPILE_OPTION "-std=c++1z")
      set(CMAKE_CXX17_EXTENSION_COMPILE_OPTION "-std=gnu++1z")
    endif()
endif()

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

add_subdirectory(interface)
add_subdirectory(lua)
add_subdirectory(video)
add_subdirectory(audio)

include_directories(lua)

set(HEADERS CInput.h        GsEventContainer.h       PointDevice.h
Configurator.h  GsEvent.h           GsTimer.h         Singleton.h
GsApp.h         GsGear.h            GsTTFSystem.h     TypeDefinitions.h
GsArguments.h   GsLogging.h         GsVirtualinput.h  Vector2D.h
GsEngine.h      GsLua.h             InputEvents.h     CRingBuffer.h
direction.h )

set(SRCS CInput.cpp       GsEngine.cpp          GsLogging.cpp  GsTimer.cpp
GsApp.cpp        GsEventContainer.cpp  GsLua.cpp      GsTTFSystem.cpp
GsArguments.cpp  GsEvent.cpp           TypeDefinitions.cpp
)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)
target_link_libraries(${PROJECT_NAME} GsKit_base_lua)
target_link_libraries(${PROJECT_NAME} GsKit_base_video)
target_link_libraries(${PROJECT_NAME} GsKit_base_audio)

target_link_libraries(${PROJECT_NAME} GsKit_widgets)

=== GsKit/fileio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

Project(GsKit_fileio)

set(HEADERS CConfiguration.h  IniReader.h  ResourceMgmt.h fileio.h)

set(SRCS CConfiguration.cpp  IniReader.cpp  ResourceMgmt.cpp fileio.cpp)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)

=== GsKit/graphics/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

Project(GsKit_graphics)

set(HEADERS cgttf.h   GsFont.h     GsGraphics.h    GsSurface.h
    GsTrueTypeFont.h  GsBitmap.h   GsFontLegacy.h  GsPalette.h
    GsTexture.h       GsCursor.h   GsGametext.h    GsSprite.h
    GsTilemap.h       GsDynColor.h CColorMerge.h   CDimDark.h
    GsScrollsurface.h
    GsTextureElem.cpp
    CFlash.h          CPixelate.h    CScrollEffect.h    CVibrate.h)

set(SRCS cgttf.cpp     GsFontLegacy.cpp  GsSprite.cpp   GsTrueTypeFont.cpp
    GsBitmap.cpp       GsGametext.cpp    GsSurface.cpp
    GsCursor.cpp       GsGraphics.cpp    GsTexture.cpp
    GsScrollsurface.cpp
    GsFont.cpp         GsPalette.cpp     GsTilemap.cpp GsDynColor.cpp
    CColorMerge.cpp    CDimDark.cpp      CPixelate.cpp CFlash.cpp
    GsTextureElem.cpp
    CScrollEffect.cpp  CVibrate.cpp  )


#include_directories(${SDL_INCLUDE_DIR})


add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_base_interface)
target_link_libraries(${PROJECT_NAME} GsKit_base)
target_link_libraries(${PROJECT_NAME} GsKit_fileio)

=== GsKit/widgets/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

Project(GsKit_widgets)

set(HEADERS down.h            GsComboSelection.h  GsMiniTextViewer.h  GsSelectableText.h
    GsBanner.h        GsControl.h         GsNumberControl.h   GsText.h
    GsBaseMenu.h      GsDialog.h          GsProgressbar.h     GsTextSelectionList.h
    GsSelectionList.h
    GsBitmapBox.h     GsFrame.h           GsRegister.h        GsWidget.h
    GsBitmapButton.h  GsInputText.h       GsScrollbar.h       GsWidgetsManager.h
    GsButton.h        GsMenuController.h  GsScrollingFrame.h  up.h
    GsSelectableChkboxItem.h GsCheckbox.h)

set(SRCS GsBanner.cpp          GsFrame.cpp           GsScrollingFrame.cpp
    GsBaseMenu.cpp        GsInputText.cpp       GsSelectableText.cpp
    GsBitmapBox.cpp       GsMenuController.cpp  GsText.cpp
    GsBitmapButton.cpp    GsMiniTextViewer.cpp  GsTextSelectionList.cpp
    GsSelectionList.cpp
    GsButton.cpp          GsNumberControl.cpp   GsWidget.cpp
    GsComboSelection.cpp  GsProgressbar.cpp     GsWidgetsManager.cpp
    GsControl.cpp         GsRegister.cpp
    GsDialog.cpp          GsScrollbar.cpp
    GsSelectableChkboxItem.cpp GsCheckbox.cpp)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_graphics)

=== GsKit/base/interface/CMakeLists.txt ===
# CMake file for development of Commander Genius (taken from OLX)
# This CMake file is used under Linux normally.

cmake_minimum_required(VERSION 3.7)

Project(GsKit_base_interface)

set(HEADERS Base64.h         Event.h       MathLib.h        Ref.h          Utils.h
Color.h          EventQueue.h  misc.h           StringBuf.h
ConfigHandler.h  FindFile.h    Mutex.h          StringUtils.h
CrashHandler.h   Geometry.h    ReadWriteLock.h  ThreadPool.h
Debug.h          Iterator.h    RefCounter.h     Unicode.h )

set(SRCS Base64.cpp         CrashHandler.cpp  Geometry.cpp     ThreadPool.cpp
Color.cpp          Debug.cpp         StringBuf.cpp    Unicode.cpp
ConfigHandler.cpp  FindFile.cpp      StringUtils.cpp  MathLib.cpp)

set(HEADERS ${HEADERS}
    property_tree/property_tree.h
    property_tree/xml_parser.h)

set(SRCS ${SRCS}
    property_tree/property_tree.cpp
    property_tree/xml_parser.cpp)

IF (NOT Boost_FOUND OR USE_BOOST)
        set(HEADERS ${HEADERS} property_tree/tinyxml2.h)
        set(SRCS ${SRCS} property_tree/tinyxml2.cpp)
endif(NOT Boost_FOUND OR USE_BOOST)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)

if(SDL2_FOUND)
    message(STATUS "Using shared SDL Version 2 for ${PROJECT_NAME}")

    #target_include_directories(${PROJECT_NAME} PUBLIC ${SDL2_INCLUDE_DIRS})

    target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${SDL2_INCLUDE_DIRS}>
        $<INSTALL_INTERFACE:${SDL2_INCLUDE_DIRS}>
    )


    target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${SDL2_INCLUDE_DIR}>
        $<INSTALL_INTERFACE:${SDL2_INCLUDE_DIR}>
    )

    message(STATUS "SDL2_INCLUDE_DIRS =  ${SDL2_INCLUDE_DIRS}")
    message(STATUS "SDL2_INCLUDE_DIR =  ${SDL2_INCLUDE_DIR}")
    message(STATUS "SDL2_MIXER_INCLUDE_DIRS =  ${SDL2_MIXER_INCLUDE_DIRS}")
    message(STATUS "SDL2_IMAGE_INCLUDE_DIRS =  ${SDL2_IMAGE_INCLUDE_DIRS}")
    message(STATUS "SDL2_TTF_INCLUDE_DIRS =  ${SDL2_TTF_INCLUDE_DIRS}")

else()
    message(FATAL_ERROR "SDL2 was not detected!")
endif(SDL2_FOUND)


target_link_libraries(${PROJECT_NAME}
    ${SDL2_LIBRARY}
    ${SDL2_IMAGE_LIBRARIES}
    ${SDL2_MIXER_LIBRARIES}
    ${SDL2_TTF_LIBRARIES})

=== GsKit/base/lua/CMakeLists.txt ===
# CMake file for development of Commander Genius (taken from OLX)
# This CMake file is used under Linux normally. 
    
cmake_minimum_required(VERSION 3.7)

Project(GsKit_base_lua)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)


if(UNIX)
    add_definitions(-DLUA_USE_POSIX)
endif()

set(HEADERS lapi.h     ldebug.h  llex.h     lopcodes.h  lstring.h  lua.h      lzio.h
lauxlib.h  ldo.h     llimits.h  lparser.h   ltable.h   lualib.h
lcode.h    lfunc.h   lmem.h     lprefix.h   ltm.h      lundump.h
lctype.h   lgc.h     lobject.h  lstate.h    luaconf.h  lvm.h
)

set(SRCS lapi.c      lcorolib.c  ldump.c   llex.c      lopcodes.c  lstrlib.c
lauxlib.c   lctype.c    lfunc.c   lmathlib.c  loslib.c    ltable.c   lundump.c
lbaselib.c  ldblib.c    lgc.c     lmem.c      lparser.c   ltablib.c  lutf8lib.c
lbitlib.c   ldebug.c    linit.c   loadlib.c   lstate.c    ltm.c      lvm.c
lcode.c     ldo.c       liolib.c  lobject.c   lstring.c   lua.c      lzio.c
)
    
add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

=== GsKit/base/video/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

Project(GsKit_base_video)


set(HEADERS CEffects.h  CSDLVideo.h   CVideoDriver.h  GsEffectController.h
COpenGL.h   CVidConfig.h  CVideoEngine.h
scaler/CScaler.h  scaler/scale2x.h  scaler/scale3x.h  scaler/scalebit.h)

set(SRCS COpenGL.cpp  CSDLVideo.cpp  CVidConfig.cpp  CVideoDriver.cpp  CVideoEngine.cpp
scaler/CScaler.cpp  scaler/scale2x.cpp  scaler/scale3x.cpp  scaler/scalebit.cpp)

add_library(${PROJECT_NAME} ${HEADERS} ${SRCS})

target_link_libraries(${PROJECT_NAME} GsKit_graphics)

=== src/engine/core/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})

add_subdirectory(menu)
add_subdirectory(mode)
add_subdirectory(VGamepads)

set(SRCS ActionFormat.cpp
         CBehaviorEngine.cpp
         CCamera.cpp
         CHUD.cpp
         CIntro.cpp
         CMap.cpp
         CMessages.cpp
         CObjectCollision.cpp
         CPassive.cpp
         CPhysicsSettings.cpp
         CPlane.cpp
         CPlanes.cpp
         CResourceLoader.cpp
         CSettings.cpp
         CSpriteObject.cpp
         GameEngine.cpp
         inventory.cpp
         textmode.cpp
         scrollingplane.cpp


         ActionFormat.h
         CBehaviorEngine.h
         CCamera.h
         CEvent.h
         Cheat.h
         CHUD.h
         CIntro.h
         CMap.h
         CMessages.h
         CPassive.h
         CPhysicsSettings.h
         CPlane.h
         CPlanes.h
         CResourceLoader.h
         CSettings.h
         CSpriteObject.h
         GameEngine.h
         inventory.h
         objenums.h
         options.h
         Playerdefines.h
         spritedefines.h
         textmode.h
         scrollingplane.h)

add_library(engine_core STATIC ${SRCS})

target_link_libraries(engine_core engine_core_menu)
target_link_libraries(engine_core engine_core_mode)
target_link_libraries(engine_core engine_core_vgamepad)

Target_link_libraries(engine_core GsKit)

=== src/engine/core/VGamepads/CMakeLists.txt ===

include_directories(${SDL_INCLUDE_DIR})


set(SRCS 
button1.h
button2.h
button3.h
button4.h
buttonClose.h
buttonConfirm.h
buttonStart.h
dpad.h
vgamepadsimple.cpp
vgamepadsimple.h
)

add_library(engine_core_vgamepad STATIC ${SRCS})

Target_link_libraries(engine_core_vgamepad GsKit)

=== debian/changelog ===
commandergenius (2.0.1ppa1) xenial; urgency=low

  *  Upstream update to version 2.0.1
  *  Many bug fixes, better performance
  *  Much improved download manager

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 11 Jan 2018 18:40:08 +0100

commandergenius (1.9.8ppa3) xenial; urgency=low

  *  Modern style option finally does something (translucent Keen in hidden areas)
  *  A lot of more and improved error catching
  *  Lots of bug fixes
  *  Improved mods compatibility

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 05 Mar 2017 10:33:29 +0100

commandergenius (1.9.8ppa2) xenial; urgency=low

  *  More Python support (lindsey messages)
  *  Improved die logic
  *  More accesable level in certain mods

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 15 Jan 2017 14:51:39 +0100

commandergenius (1.9.8ppa1) xenial; urgency=low

  *  More Python support and fixes
  *  Computer Wrist and Ending Story in Episode in early stages but starting to work

 -- Gerhard Stein <gerstrong@gmail.com>  Sat, 14 Jan 2017 15:27:54 +0100

commandergenius (1.9.7ppa1) xenial; urgency=low

  *  Python3 support for AI (Keen 9 better supported with that)

 -- Gerhard Stein <gerstrong@gmail.com>  Mon, 26 Dec 2016 18:33:55 +0100

commandergenius (1.9.5ppa5) xenial; urgency=low

  *  Deadlock fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Wed, 29 Jun 2016 19:35:41 +0200

commandergenius (1.9.5ppa4) xenial; urgency=low

  *  Search path fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Wed, 29 Jun 2016 16:06:38 +0200

commandergenius (1.9.5ppa3) xenial; urgency=low

  *  Crash fixes
  *  Improved Game Center

 -- Gerhard Stein <gerstrong@gmail.com>  Wed, 29 Jun 2016 15:12:27 +0200

commandergenius (1.9.5ppa2) xenial; urgency=low

  *  Xenial build set

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 26 Jun 2016 19:00:44 +0200

commandergenius (1.9.5ppa1) trusty; urgency=low

  *  New Downloader which automatically downloads your games
  *  Sandwich menu for touchpad devices
  *  Cheats menu for those who lack of inputting shortcuts
  *  Lots of bugs this time in the audio department

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 26 Jun 2016 18:38:25 +0200

commandergenius (1.9.1ppa2) trusty; urgency=low

  *  Cmake version 2.8.12 compatible

 -- Gerhard Stein <gerstrong@gmail.com>  Tue, 19 Jan 2016 19:13:56 +0100

commandergenius (1.9.1ppa1) trusty; urgency=low

  *  Support for Keen Dreams Mods
  *  A lot of bug fixes especially for Keen Dreams

 -- Gerhard Stein <gerstrong@gmail.com>  Sat, 16 Jan 2016 20:10:54 +0100

commandergenius (1.9.0ppa1) trusty; urgency=low

  *  Support for Keen Dreams

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 06 Dec 2015 14:02:29 +0100

commandergenius (1.8.4ppa3) trusty; urgency=low

  *  Update of Commander Genius

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 05 Nov 2015 19:08:05 +0100

 

commandergenius (1.8.4ppa2) trusty; urgency=low

  *  Update of Commander Genius

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 05 Nov 2015 17:49:17 +0100

commandergenius (1.8.4ppa1) trusty; urgency=low

  *  Update of Commander Genius

 -- Gerhard Stein <gerstrong@gmail.com>  Sun, 01 Nov 2015 21:44:28 +0100

commandergenius (1.8.3ppa3) trusty; urgency=low

  *  Reference fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Tue, 29 Sep 2015 18:07:29 +0200

commandergenius (1.8.3ppa2) trusty; urgency=low

  *  Support for CMake 2.8 put back  

 -- Gerhard Stein <gerstrong@gmail.com>  Tue, 29 Sep 2015 17:32:59 +0200

commandergenius (1.8.3ppa1) trusty; urgency=low

  *  Better effects  
  *  Prepared code for Keen Dreams

 -- Gerhard Stein <gerstrong@gmail.com>  Tue, 29 Sep 2015 17:19:43 +0200

commandergenius (1.8.2.1ppa1) trusty; urgency=low

  *  Message Box is shown in Keen 5 when fuses are broken
  *  Soft collision detection, so Sprites can go through narrow sections in the games (Keen 5 for example has some levels with this issue)$

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 02 Jul 2015 14:07:37 +0200

commandergenius (1.8.2ppa3) trusty; urgency=low

  * Rebuild

 -- Gerhard Stein <gerstrong@gmail.com>  Sat, 27 Jun 2015 10:21:28 +0200

commandergenius (1.8.2ppa2) trusty; urgency=low

  * Updated documentation rules

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 25 Jun 2015 19:46:39 +0200
 

commandergenius (1.8.2ppa1) trusty; urgency=low

  * AI fixes
  * Better SDL 2 support
  * Improved OpenGL support

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 22 Jun 2015 18:26:00 +0100

commandergenius (1.8.1.4ppa2) trusty; urgency=low

  * Galaxy engine fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 15 Jan 2015 19:44:37 +0100

commandergenius (1.8.1.4ppa1) trusty; urgency=low

  * Caches fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 15 Jan 2015 15:20:47 +0100

commandergenius (1.8.1.4) trusty; urgency=low

  * Version update. This solves some vorticon issues
    and enhances the mod support.

 -- Gerhard Stein <gerstrong@gmail.com>  Thu, 15 Jan 2015 13:39:49 +0100

commandergenius (1.8.1.3ppa9) trusty; urgency=low

  * Package dependency fixes

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 16:21:31 +0100
 

commandergenius (1.8.1.3ppa8) trusty; urgency=low

  * Removed Temp files

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 16:21:31 +0100

commandergenius (1.8.1.3ppa7) trusty; urgency=low

  * Corrected dependency of SDL2 Image

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 15:59:48 +0100

commandergenius (1.8.1.3ppa6) trusty; urgency=low

  * Cleanups

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 14:46:31 +0100

commandergenius (1.8.1.3ppa5) trusty; urgency=low

  * Removed annoying Cmake caches

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 14:30:52 +0100

commandergenius (1.8.1.3ppa4) trusty; urgency=low

  * CMake and Build essential dependencies added. Of course we need those!

 -- Gerhard Stein <gerstrong@gmail.com>  Fri, 02 Jan 2015 14:24:15 +0100

commandergenius (1.8.1.3ppa3) trusty; urgency=low

  * Source package fixes



=== debian/control ===
Source: commandergenius
Section: contrib/games
Priority: extra
Maintainer: Gerhard Stein <gerstrong@gmail.com>
Build-Depends: cmake, libsdl2-dev, libsdl2mixer-dev,libsdl2ttf-dev, libboost1.58-dev, libsdl2-image-dev, libcurl4-openssl-dev, debhelper (>= 9), python3-dev (>= 3.5)
Homepage: https://clonekeenplus.sourceforge.io

Package: commandergenius
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Engine used to play the "Commander Keen" game series
 Commander-Genius aka CloneKeenPlus is an engine which interprets
 Commander Keen 1-6 (Vorticons and Galaxy Series).
 .
 As fans and developers we try to implement new features, improve the
 gameplay and give the feeling, you are playing the original game.
 .
 Obviously you need the game data of the games to play it.
 No worries, we provide an integrated stores where you download
 them automatically and let CG configure everything for you.
 Episode 2, 3, 5 and 6 are registered versions which can be
 purchased by 3D Realms or Apogee, or bought by someone else.
 If you still have the old games of the registered version,
 then copy those into a reachable directory and give it a try.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="Release" -DUSE_PYTHON3=ON -DREFKEEN=ON -DDOWNLOADER=ON
